#include <SPI.h>

const int trigPin = 26; // Définissez les broches du capteur HC-SR05
const int echoPin = 25;
const int ssPin = 5; // Choisissez une broche pour SS
float distance;

void setup() {
  Serial.begin(115200);
  SPI.begin();
  pinMode(trigPin, OUTPUT);
  pinMode(echoPin, INPUT);
  pinMode(ssPin, OUTPUT);
  digitalWrite(ssPin, HIGH); // Désactive l'esclave au départ
}

void loop() {
  distance = getDistance();
  Serial.println(distance);
  sendDistanceSPI(distance);
  delay(1000); // Delay d'une seconde entre chaque mesure
}

float getDistance() {
  // Envoi d'un pulse ultrason
  digitalWrite(trigPin, LOW);
  delayMicroseconds(2);
  digitalWrite(trigPin, HIGH);
  delayMicroseconds(10);
  digitalWrite(trigPin, LOW);

  // Lire la durée du retour de l'écho
  long duration = pulseIn(echoPin, HIGH);

  // Calculer la distance en cm
  float distance = duration * 0.034 / 2;
  return distance;
}

void sendDistanceSPI(float distance) {
  byte *distanceBytes = (byte *) &distance;
  SPI.beginTransaction(SPISettings(14000000, MSBFIRST, SPI_MODE0));
  digitalWrite(ssPin, LOW); // Active l'esclave
  for (int i = 0; i < sizeof(float); i++) {
    SPI.transfer(distanceBytes[i]);
  }
  digitalWrite(ssPin, HIGH); // Désactive l'esclave
  SPI.endTransaction();
}
